.nolist
#include <avr/io.h>
#define T0L	r0
#define T0H	r1
#define _P1LL	r2
#define _P1LH	r3
#define _P1HL	r4
#define _P1HH	r5
#define _P2LL	r6
#define _P2LH	r7
#define _P2HL	r8
#define _P2HH	r9
#define _TMPL	r10
#define _TMPH	r11
#define AL	r16
#define AH	r17
#define CL	r20
#define CH	r21
#define ZL	r30
#define ZH	r31
.list

	.section .bss
Acc64:	.ds.b	8


	.section .text

.global INT0_vect
.func INT0_vect
;7
INT0_vect:
	sts	0x7FFE, _TMPL	; 4
	sts	0x7FFF, _TMPH	; 4
;15
	push	AL		; 2
	in	AL, _SFR_IO_ADDR(SREG)	; 1
	push	T0L		; 2
	push	T0H		; 2
	push	AL		; 2
	push	AH		; 2
	push	CL		; 2
	push	CH		; 2
	push	ZL		; 2
	push	ZH		; 2
;34
	lds	T0L, Omega1+0	; 2
	add	_P1LL, T0L	; 1
	lds	T0L, Omega1+1	; 2
	adc	_P1LH, T0L	; 1
	lds	T0L, Omega1+2	; 2
	adc	_P1HL, T0L	; 1
	lds	T0L, Omega1+3	; 2
	adc	_P1HH, T0L	; 1
	movw	ZL, _P1HL	; 1
	andi	ZL, 0b11111110	; 1
	andi	ZH, 0b00111111	; 1
	ori	ZH, 0b10000000	; 1
	ld	AL, Z+		; 4
	ld	AH, Z+		; 4
	lds	CL, Gain+0	; 2
	lds	CH, Gain+1	; 2
;62
	clr	ZL		; 1
	fmuls	AH, CH		; 2
	movw	_TMPL, T0L	; 1
	fmul	AL, CL		; 2
	adc	_TMPL, ZL	; 1
	mov	ZH, T0H		; 1
	fmulsu	AH, CL		; 2
	sbc	_TMPH, ZL	; 1
	add	ZH, T0L		; 1
	adc	_TMPL, T0H	; 1
	adc	_TMPH, ZL	; 1
	fmulsu	CH, AL		; 2
	sbc	_TMPH, ZL	; 1
	add	ZH, T0L		; 1
	adc	_TMPL, T0H	; 1
	adc	_TMPH, ZL	; 1
;82
	lds	T0L, Omega2+0	; 2
	add	_P2LL, T0L	; 1
	lds	T0L, Omega2+1	; 2
	adc	_P2LH, T0L	; 1
	lds	T0L, Omega2+2	; 2
	adc	_P2HL, T0L	; 1
	lds	T0L, Omega2+3	; 2
	adc	_P2HH, T0L	; 1
	movw	ZL, _P2HL	; 1
	andi	ZL, 0b11111110	; 1
	ori	ZH, 0b11000000	; 1
	ld	AL, Z+		; 4
	ld	AH, Z+		; 4
	lds	CL, Gain+0	; 2
	lds	CH, Gain+1	; 2
;109
	sts	0x7FFE, _TMPL	; 4
	sts	0x7FFF, _TMPH	; 4
;117
	clr	ZL		; 1
	fmuls	AH, CH		; 2
	movw	_TMPL, T0L	; 1
	fmul	AL, CL		; 2
	adc	_TMPL, ZL	; 1
	mov	ZH, T0H		; 1
	fmulsu	AH, CL		; 2
	sbc	_TMPH, ZL	; 1
	add	ZH, T0L		; 1
	adc	_TMPL, T0H	; 1
	adc	_TMPH, ZL	; 1
	fmulsu	CH, AL		; 2
	sbc	_TMPH, ZL	; 1
	add	ZH, T0L		; 1
	adc	_TMPL, T0H	; 1
	adc	_TMPH, ZL	; 1
;129
	pop	ZH		; 2
	pop	ZL		; 2
	pop	CH		; 2
	pop	CL		; 2
	pop	AH		; 2
	pop	AL		; 2
	pop	T0H		; 2
	pop	T0L		; 2
	out	_SFR_IO_ADDR(SREG), AL	; 1
	pop	AL		; 2
	reti			; 4
;157
.endfunc




.global get_statics
.func get_statics
get_statics:
	movw	r26, r24
	clr	r25
	ldi	ZL, 2		; Clear work regs
	ldi	ZH, 0
1:	st	Z+, r25
	cpi	ZL, 12
	brne	1b

	ldi	ZL, lo8(0x8000)	; Z = 0x8000;
	ldi	ZH, hi8(0x8000)
2:	ld	r22, Z+		; r23:r22 = Z+;
	ld	r23, Z+
	cp	r8, r22		; if (r9:r8 < r23:r22) r9:r8 = r23:r22; (+Peak)
	cpc	r9, r23
	brge	21f
	movw	r8, r22
21:	cp	r10, r22	; if (r11:r10 >= r23:r22) r11:r10 = r23:r22; (-Peak)
	cpc	r11, r23
	brlt	22f
	movw	r10, r22
22:	muls	r23, r23	; r21:r18 = r23:r22 * r23:r22; (Square)
	movw	r20, r0
	mul	r22, r22
	movw	r18, r0
	mulsu	r23, r22
	sbc	r21, r25
	add	r19, r0
	adc	r20, r1
	adc	r21, r25
	mulsu	r23, r22
	sbc	r21, r25
	add	r19, r0
	adc	r20, r1
	adc	r21, r25
	add	r2, r18		; r7:r2 += r21:r18;
	adc	r3, r19
	adc	r4, r20
	adc	r5, r21
	adc	r6, r25
	adc	r7, r25
	cpi	ZH, hi8(0xC000)	; until (Z == 0xC000);
	brne	2b

	ldi	ZL, 13		; r7:r2 /= 8192; (Mean)
3:	lsr	r7
	ror	r6
	ror	r5
	ror	r4
	ror	r3
	ror	r2
	dec	ZL
	brne	3b

	clr	r6		; r21:r20 = sqrt(r5:r2); (rms)
	clr	r7
	clr	r18
	clr	r19
	ldi	r20, 1
	clr	r21
	clr	r22
	clr	r23
	ldi	r24, 16
4:	lsl	r2
	rol	r3
	rol	r4
	rol	r5
	rol	r6
	rol	r7
	rol	r18
	rol	r19
	lsl	r2
	rol	r3
	rol	r4
	rol	r5
	rol	r6
	rol	r7
	rol	r18
	rol	r19
	brpl	41f
	add	r6, r20
	adc	r7, r21
	adc	r18, r22
	adc	r19, r23
	rjmp	42f
41:	sub	r6, r20
	sbc	r7, r21
	sbc	r18, r22
	sbc	r19, r23
42:	lsl	r20
	rol	r21
	rol	r22
	andi	r20, 0b11111000
	ori	r20, 0b00000101
	sbrc	r19, 7
	subi	r20, 2
	dec	r24
	brne	4b
	lsr	r22
	ror	r21
	ror	r20
	lsr	r22
	ror	r21
	ror	r20
	movw	r30, r20
	rcall	9f

	ldi	r25, 0x80	; r9:r8 += 0x8000;
	add	r9, r25
	add	r11, r25	; r11:r10 += 0x8000;
	sub	r8, r10		; r9:r8 -= r11:r10; (p-p)
	sbc	r9, r11
	movw	r30, r8
	rcall	9f

	clr	r1
	ret

9:				; r23:r20 = 0x7FFF0000 / r31:r30;
	ldi	r20, lo8(0x7FFF0000)
	ldi	r21, hi8(0x7FFF0000)
	ldi	r22, hlo8(0x7FFF0000)
	ldi	r23, hhi8(0x7FFF0000)
	clr	r24
	clr	r25
	ldi	r18, 32
91:	lsl	r20
	rol	r21
	rol	r22
	rol	r23
	rol	r24
	rol	r25
	brcs	92f
	cp	r24, r30
	cpc	r25, r31
	brcs	93f
92:	sub	r24, r30
	sbc	r25, r31
	inc	r20
93:	dec	r18
	brne	91b
	st	X+, r20
	st	X+, r21
	st	X+, r22
	st	X+, r23
	ret
.endfunc




.global freq2omega
.func freq2omega
freq2omega:
	movw	r20, r22
	movw	r22, r24
	sub	r24, r24
	sub	r25, r25
	sub	r26, r26
	ldi	r27, 33
1:	brcc	2f
	subi	r24, lo8(-6871948)
	sbci	r25, hi8(-6871948)
	sbci	r26, hlo8(-6871948)
2:	lsr	r26
	ror	r25
	ror	r24
	ror	r23
	ror	r22
	ror	r21
	ror	r20
	dec	r27
	brne	1b
	sbrs	r21, 7
	ret
	subi	r22, lo8(-1)
	sbci	r23, hi8(-1)
	sbci	r24, hlo8(-1)
	sbci	r25, hlo8(-1)
	ret
.endfunc

